<template>
  <form ref="form" @submit.prevent="">
    <div>
      <label for="id_title" class="">{{ $t("searchform.title") }}</label>
      <div>
        <input
          type="text"
          name="title"
          :placeholder="$t('searchform.yourtitle')"
          maxlength="500"
          class="form-control"
          v-model="title"
          id="id_title"
          ref="input_title"
        />
      </div>
    </div>
    <div class="mt-1">
      <label for="id_abstract" class="">{{ $t("searchform.abstract") }}</label>
      <div>
        <textarea
          name="abstract"
          cols="40"
          rows="5"
          :placeholder="$t('searchform.yourabstract')"
          maxlength="5000"
          class="form-control"
          v-model="abstract"
          id="id_abstract"
          ref="input_abstract"
        ></textarea>
      </div>
    </div>
    <div class="mt-1">
      <label for="id_references" class="">{{ $t("searchform.references") }}</label>
      <tooltip-help :text="$t('searchform.reference_tooltip')" />
      <div>
        <textarea
          name="references"
          cols="40"
          rows="5"
          :placeholder="$t('searchform.yourreferences')"
          maxlength="50000"
          class="form-control"
          v-model="references"
          id="id_references"
          ref="input_references"
        ></textarea>
      </div>
    </div>
    <button @click="formSubmit" class="btn btn-primary mb-2 mt-2">
      {{ $t("searchform.check") }}
    </button>
    <button @click="clearForm" class="btn btn-danger m-2">
      {{ $t("searchform.clear") }}
    </button>
  </form>
</template>

<script>
import TooltipHelp from '@/components/TooltipHelp.vue'

export default {
  name: 'SearchForm',
  components: { TooltipHelp },
  methods: {
    formSubmit () {
      this.$store.dispatch('journalQuery')
    },
    clearForm () {
      // clear inputs and result list (hide results)
      this.$store.commit('RESET_FORM')
    }
  },
  computed: {
    // use computed properties to directly change the vuex store values
    title: {
      set (v) {
        this.$store.commit('SET_TITLE', v)
      },
      get () {
        return this.$store.state.title
      }
    },
    abstract: {
      set (v) {
        this.$store.commit('SET_ABSTRACT', v)
      },
      get () {
        return this.$store.state.abstract
      }
    },
    references: {
      set (v) {
        this.$store.commit('SET_REFERENCES', v)
      },
      get () {
        return this.$store.state.references
      }
    }
  }
}
</script>
